package com.qmth.sop.business.service.impl;

import com.baomidou.mybatisplus.annotation.InterceptorIgnore;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.sop.business.bean.dto.DingStatisticByPersonDto;
import com.qmth.sop.business.entity.TBDingStatistic;
import com.qmth.sop.business.entity.TBDingStatisticByPerson;
import com.qmth.sop.business.mapper.TBDingStatisticByPersonMapper;
import com.qmth.sop.business.service.TBDingStatisticByPersonService;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 工时统计-按人员统计 服务实现类
 * </p>
 *
 * @author CaoZixuan
 * @since 2024-09-09
 */
@Service
public class TBDingStatisticByPersonServiceImpl extends ServiceImpl<TBDingStatisticByPersonMapper, TBDingStatisticByPerson> implements TBDingStatisticByPersonService {

    @Transactional
    @Override
    public void buildStatisticByPerson(List<TBDingStatistic> datasource) {
        List<TBDingStatisticByPerson> result = new ArrayList<>();
        for (TBDingStatistic tbDingStatistic : datasource) {
            TBDingStatisticByPerson tbDingStatisticByPerson = new TBDingStatisticByPerson();
            BeanUtils.copyProperties(tbDingStatistic, tbDingStatisticByPerson);
            tbDingStatisticByPerson.setUserInfo(
                    tbDingStatistic.getUserArchivesName() + "(" + tbDingStatistic.getUserArchivesCode() + ")");
            result.add(tbDingStatisticByPerson);
        }
        this.baseMapper.truncateTable();
        this.saveBatch(result);
    }

    @Override
    public IPage<DingStatisticByPersonDto> findStatisticByPersonPage(Long serviceId, Integer pageNumber,
            Integer pageSize) {
        return this.baseMapper.findStatisticByPersonPage(new Page<>(pageNumber, pageSize), serviceId);
    }

    @Override
    public List<DingStatisticByPersonDto> findStatisticByPersonList(Long serviceId) {
        return this.baseMapper.findStatisticByPersonList(serviceId);
    }
}
